using ProjectWarmlyShip;
using ProjectWarmlyShip.DrawningObjects;
using ProjectWarmlyShip.MovementStrategy;
using static ProjectWarmlyShip.DirectionType;
namespace ProjectWarmlyShipHard
{
    public partial class FormWarmlyShip : Form
    {
        /// <summary>
        /// -   
        /// </summary>
        private DrawningShip? _drawingWarmlyShip;
        /// <summary>
        ///  
        /// </summary>
        private AbstractStrategy? _abstractStrategy;
        /// <summary>
        ///  
        /// </summary>
        public FormWarmlyShip()
        {
            InitializeComponent();
            comboBoxStrategy.Items.Add("  ");
            comboBoxStrategy.Items.Add("  ");
        }
        /// <summary>
        ///   
        /// </summary>
        private void Draw()
        {
            if (_drawingWarmlyShip == null)
            {
                return;
            }
            Bitmap bmp = new(pictureBoxWarmlyShip.Width, pictureBoxWarmlyShip.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _drawingWarmlyShip.DrawTransport(gr);
            pictureBoxWarmlyShip.Image = bmp;
        }
        /// <summary>
        ///    ""
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonCreate_Click(object sender, EventArgs e)
        {
            Random random = new();
            _drawingWarmlyShip = new DrawningShip(random.Next(100, 300), random.Next(1000, 3000),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)), pictureBoxWarmlyShip.Width, pictureBoxWarmlyShip.Height, random.Next(1, 4), random.Next(1, 4));

            _drawingWarmlyShip.SetPosition(random.Next(10, 100), random.Next(10, 100));
            Draw();
        }
        /// <summary>
        ///    "   "
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonCreateDeckShip_Click(object sender, EventArgs e)
        {
            Random random = new();
            _drawingWarmlyShip = new DrawingWarmlyShip(random.Next(100, 300), random.Next(1000, 3000),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)),
            pictureBoxWarmlyShip.Width, pictureBoxWarmlyShip.Height, random.Next(1, 4), random.Next(1, 4));
            _drawingWarmlyShip.SetPosition(random.Next(10, 100), random.Next(10, 100));
            Draw();
        }
        /// <summary>
        ///   
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonMove_Click(object sender, EventArgs e)
        {
            if (_drawingWarmlyShip == null)
            {
                return;
            }
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _drawingWarmlyShip.MoveTransport(DirectionType.Up);
                    break;
                case "buttonDown":
                    _drawingWarmlyShip.MoveTransport(DirectionType.Down);
                    break;
                case "buttonLeft":
                    _drawingWarmlyShip.MoveTransport(DirectionType.Left);
                    break;
                case "buttonRight":
                    _drawingWarmlyShip.MoveTransport(DirectionType.Right);
                    break;
            }
            Draw();
        }
        /// <summary>
        ///    ""
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonStep_Click(object sender, EventArgs e)
        {
            if (_drawingWarmlyShip == null)
            {
                return;
            }
            if (comboBoxStrategy.Enabled)
            {
                _abstractStrategy = comboBoxStrategy.SelectedIndex
                switch
                {
                    0 => new MoveToCenter(),
                    1 => new MoveToBorder(),

                };
                if (_abstractStrategy == null)
                {
                    return;
                }
                _abstractStrategy.SetData(new DrawningObjectShip(_drawingWarmlyShip), pictureBoxWarmlyShip.Width, pictureBoxWarmlyShip.Height);
                comboBoxStrategy.Enabled = false;
            }
            if (_abstractStrategy == null)
            {
                return;
            }
            _abstractStrategy.MakeStep();
            Draw();
            if (_abstractStrategy.GetStatus() == Status.Finish)
            {
                comboBoxStrategy.Enabled = true;
                _abstractStrategy = null;
            }
        }
    }
}